;Hi there!  My name is Paul Talbot and you are viewing my program!

;This is the source code to my first NES game, Pong. 

	PROCESSOR 6502

LIMIT EQU #$0050
ATTSIZE EQU #$0010
SPRITESIZE EQU #$0012
PALETTESIZE EQU #$0020
PLAYER EQU #$0022
MOVE EQU #$0024
MOVE2 EQU #$0026
MOVE3 EQU #$0028
MOVE4 EQU #$0030
MOVEX EQU #$0032
MOVEY EQU #$0034
BALLSPEED EQU #$0036
ANGLE EQU #$0038
HITX EQU #$0052
HITY EQU #$0054
POINT1 EQU #$0056
POINT2 EQU #$0058
RANGE EQU #$0060
PAUSE EQU #$0062
LIMITY EQU #$0064
INCSPEED EQU #$0070
ENSOUND EQU #$0072
LOOPS EQU #$0074
SPRITES EQU #$0700


	ORG $C000

	cld
	sei
	ldx #$ff
	txs
.VBlank lda $2002
	bpl .VBlank
	ldx #$00
	stx $2000
	stx $2001	
	ldy #$06	 
	sty $01		
	ldy #$00
	sty $00
	lda #$40		;Initialize variables used
	sta ATTSIZE		;for writing data in PONG.ASM
	lda #$48
	sta SPRITESIZE
	lda #$20
	sta PALETTESIZE
	
.ClearWRAM  sta ($00),y		
	dey
	bne .ClearWRAM
	dec $01
	bpl .ClearWRAM
	ldx #$3F
	stx $2006
	ldx #$00
	stx $2006
	ldx #$27
	ldy #$20
.ClearPal stx $2007		
	dey
	bne .ClearPal
.SetPallettes ldx #$3F		;Now, set pallettes so data can be
	stx $2006		;written to them.
	ldx #$00
	stx $2006
	ldx #$00
.ApplyToPal lda .Pal,x
	sta $2007
	inx			;Write the data into the pallettes
	cpx PALETTESIZE
	bne .ApplyToPal
.SetAttributeTbl ldx #$23
	stx $2006
	ldx #$C0		;Set attribute table so data can be
	stx $2006		;written.
	ldx #$00	
.ApplyToAtt lda .Att,x
	sta $2007
	inx
	cpx ATTSIZE		;Write data to attribute tables.
	bne .ApplyToAtt
	ldx #$00
	ldx #$20
	stx $2006
	ldx #$00
	stx $2006
	ldx #$00
	ldy #$00
.SetMap1 lda .TitleMap1,X
	sta $2007
	inx
	cpx #$00			;Insert background graphics
	bne .SetMap1			
	ldy #$00					
.SetMap2 lda .TitleMap2,X
	sta $2007
	inx
	cpx #$00
	bne .SetMap2
	ldy #$00
.SetMap3 lda .TitleMap2,X
	sta $2007
	inx
	cpx #$00
	bne .SetMap3
	ldy #$00
.SetMap4 lda .TitleMap3,X
	sta $2007
	inx
	cpx #$C0
	bne .SetMap4
	ldx #$00
	lda #$00
	sta $2003
.ApplyToSprite lda .Sprite,x
	sta $2004			;Set and write data to Name 
	inx				;Tables
	cpx SPRITESIZE
	bne .ApplyToSprite
	ldx #$00
	lda #%10010000		;Display images, and do a lot of other stuff.
	sta $2000
	lda #%00011110
	sta $2001
.initialize
	lda #$FF
	sta BALLSPEED		;initialize all variables
	lda #$05
	sta INCSPEED
	lda #$CF
	sta MOVEX
	lda #$65
	sta MOVEY
	lda #$C7
	sta MOVE
	sta MOVE3
	lda #$CF
	sta MOVE2
	sta MOVE4
	lda #$01
	sta ANGLE
	lda #$FA
	sta LIMIT
	lda #$30
	sta LIMITY
	lda #$00
	sta HITX
	sta HITY
	sta POINT1
	sta POINT2
	sta PAUSE
	sta ENSOUND
	sta LOOPS

.New INCLUDE PONGANI.asm	;Include all my other 
.Ani INCLUDE PONGSPR.ASM	;files.
.Other INCLUDE FXPONG.ASM
.Sub INCLUDE PONGSUB.asm


	ORG $FF00
	
	ldx #$00
	stx $2005
	stx $2005
	rti


				;NMI, ect.
	ORG $FFFA
	dc.b #$0, #$FF, #$0, #$C0, #$0, #$C0

;Ok, that's about it for this file.  Please look at pong.txt
;for additional information and other programming notes.
;Thanks for looking at my program!

; PAUL TALBOT 2001.  ALL RIGHTS RESERVED.